"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
exports.__esModule = true;
var React = require("react");
var joint = require("jointjs");
var omit = require("lodash/omit");
var Portal_1 = require("./Portal");
var ReactJointJS = /** @class */ (function (_super) {
    __extends(ReactJointJS, _super);
    function ReactJointJS() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.paper = null;
        return _this;
    }
    ReactJointJS.prototype.componentDidMount = function () {
        var _this = this;
        this.paper = new joint.dia.Paper(__assign(__assign({}, {
            el: document.getElementById("_paper"),
            model: this.props.graph
        }), this.props.paperOptions));
        this.props.nodes.forEach(function (node) {
            var nodeElement = new joint.dia.Element(__assign(__assign({}, omit(node, "element")), { markup: "<g class=\"rotatable\"><foreignObject width=\"" + node.size.width + "px\" height=\"" + node.size.height + "px\" id=\"node_" + node.id + "\"></foreignObject></g>" }));
            node.ports.forEach(function (port) {
                return nodeElement.addPort(__assign(__assign({}, omit(port, ["element", "size"])), { markup: "<foreignObject width=\"" + port.size.width + "px\" height=\"" + port.size.height + "px\" id=\"port_" + port.id + "\" />" }));
            });
            _this.props.graph.addCell(nodeElement);
        });
        this.props.links.forEach(function (link) {
            _this.props.graph.addCell(link);
            link.toBack();
        });
        setTimeout(function () { return _this.forceUpdate(); });
    };
    ReactJointJS.prototype.render = function () {
        return (React.createElement(React.Fragment, null,
            React.createElement("div", { className: "react-joint-js-paper", id: "_paper" }),
            this.props.nodes.map(function (node) {
                return (React.createElement(React.Fragment, { key: node.id },
                    React.createElement(Portal_1["default"], { id: "node_" + node.id, key: "node_" + node.id, element: node.element }),
                    node.ports.map(function (port) {
                        return (React.createElement(Portal_1["default"], { id: "port_" + port.id, key: "port_" + port.id, element: port.element }));
                    })));
            })));
    };
    return ReactJointJS;
}(React.Component));
exports["default"] = ReactJointJS;
